'--------------------------   --------------------------------                                                                   
DECLARE  SHOW_SYSTEM_VARIABLES = off   '    Proteus    
DECLARE  FSR_CONTEXT_SAVE = OFF   '      FSR
DECLARE  REMINDERS = OFF    '    
DECLARE  WARNINGS = ON   '    
DECLARE  OPTIMISER_LEVEL 0    '                                                                      
;--------------------------  ------------------------------------
DEVICE 16F887
XTAL = 4  '    4 

CONFIG1  DEBUG_OFF, LVP_OFF, FCMEN_OFF, IESO_OFF, BOR_OFF, CPD_OFF, CP_OFF, MCLRE_OFF, PWRTE_OFF, WDT_OFF, INTRC_OSC_NOCLKOUT
CONFIG2  BOR21V, WRT_OFF

DECLARE PORTB_PULLUPS = OFF  '     PORTB
DECLARE  ALL_DIGITAL = OFF '        

  DIM Sec AS BYTE; 
  DIM Mi AS BYTE; 
  DIM Ho AS BYTE; 
  DIM Pir AS BIT;        
  DIM Raz AS BYTE;        
  DIM Digit AS BYTE;     
  DIM Cif AS BYTE ;  
  DIM TminON AS BYTE ;  
  DIM TminOFF AS BYTE ;  
  DIM ThourON AS BYTE  ;  
  DIM ThourOFF AS BYTE  ;  
  DIM tON AS WORD
  DIM tOFF AS WORD
  DIM Time AS WORD
  DIM Cycle AS BYTE  ;
  DIM keyflag AS BYTE ;
  
  SYMBOL MENUkey = PORTA.1
  SYMBOL OKkey = PORTA.3
  SYMBOL HIkey = PORTA.4
  SYMBOL LOWkey = PORTA.2
  
  SYMBOL OUT = PORTC.2
  
  
ADCON0 = %00000000
ADCON1 = %00000000
ANSEL = %00000000
ANSELH = %00000000
TRISA = %00011110   '  A -  
TRISB = %00000000   '  B -  
TRISC = %00000000   '  C -  
TRISD = %00000000   '  D -  
TRISE = %00000000   '  E -  
CM1CON0 = %00000000
CM2CON0 = %00000000
CM2CON1 = %00000000
SSPCON = %00000000
RCSTA = %00000000
PSTRCON = %00000000                                                                
'-------------------------- INTCON --------------------------------------------                                                                   
SYMBOL RBIF = INTCON.0 '     PORTB.4-PORTB.7
SYMBOL INTF = INTCON.1 '     PORTB.0(INT)
SYMBOL T0IF = INTCON.2 '   TMR0
SYMBOL RBIE = INTCON.3 '     PORTB.4-PORTB.7
SYMBOL INTE = INTCON.4 '     PORTB.0(INT) 
SYMBOL T0IE = INTCON.5 '      TMR0
SYMBOL PEIE = INTCON.6 '      
SYMBOL GIE = INTCON.7  '     
PEIE = 1 ;  
GIE = 1 ;  
                                                                 
'-------------------------- PIE1, PIR1 ----------------------------------------------                                                                   
SYMBOL TMR1IE = PIE1.0 '      TMR1
SYMBOL TMR1IF = PIR1.0 '     TMR1
SYMBOL TIMER1 = TMR1L.WORD                                                                                                                             
'--------------------------  TMR1   --------------------
CLEAR
DELAYUS 100
T1CON = %00001111
ON_INTERRUPT GOTO ISR ;     ISR
TMR1IE = 1 ' .  TMR1
TMR1IF = 0 '    TMR1
TIMER1 = 32768 ;  
'--------------------------  ------------------------------------------- 
Ho = 18
Mi = 42
ThourON = 18 
TminON = 43
ThourOFF = 18
TminOFF = 44
GOTO Main
 
 ISR:    ;  
 CONTEXT SAVE
 TMR1IF = 0 ;   
 TIMER1 = 32768 ;  
 INC Sec
 IF Sec = 60 THEN
 INC Mi
 Sec = 0
 ENDIF
 IF Mi = 60 THEN
 INC Ho
 Mi = 0                                         
 ENDIF
 IF Ho = 24 THEN
 Ho = 0
 ENDIF
 Time.0 = Mi.0 : Time.1 = Mi.1 : Time.2 = Mi.2 : Time.3 = Mi.3 : Time.4 = Mi.4 : Time.5 = Mi.5 : Time.6 = Mi.6 : Time.7 = Mi.7
 Time.8 = Ho.0 : Time.9 = Ho.1 : Time.10 = Ho.2 : Time.11 = Ho.3 : Time.12 = Ho.4 : Time.13 = Ho.5 : Time.14 = Ho.6 : Time.15 = Ho.7
 CONTEXT RESTORE

Main:
Raz = Sec DIG 0 '  
Cif = %00100000
GOSUB DecoderNP
Raz = Sec DIG 1 '  
Cif = %00010000
GOSUB DecoderNP
Raz = Mi DIG 0  '  
Cif = %00001000 
GOSUB DecoderNP
Raz = Mi DIG 1  '  
Cif = %00000100
GOSUB DecoderNP      
Raz = Ho DIG 0  '  
Cif = %00000010
GOSUB DecoderNP
Raz = Ho DIG 1  '  
Cif = %00000001
GOSUB DecoderNP
',      ?
IF tON > tOFF THEN
IF Time >= tON AND Time < tOFF THEN OUT = %1   '
IF Time >= tON AND Time > tOFF THEN OUT = %1    '
IF Time <= tON AND Time < tOFF THEN OUT = %1     '
IF Time < tON AND Time >= tOFF THEN OUT = %0      '
ENDIF                                              '     ------->     ?     
IF tON < tOFF THEN                                  '
IF Time >= tON AND Time < tOFF THEN OUT = %1         '
IF Time > tON AND Time >= tOFF THEN OUT = %0          '
IF Time < tON AND Time <= tOFF THEN OUT = %0           '
IF Time < tON AND Time >= tOFF THEN OUT = %0            '
ENDIF
IF tON = tOFF THEN OUT = 0
GOTO Main

DecoderP:  ;                                   
Digit = LOOKUPL Raz ,[$40, $79, $24, $30, $19, $12, $02, $78, $00, $10, $3f, $7F ]
GOTO Decoder  '        0.    1.   2.   3.   4.   5.   6.   7.   8.   9.   -.  off.

DecoderNP:  ;                                  
Digit = LOOKUPL Raz ,[$C0, $F9, $A4, $B0, $99, $92, $82, $F8, $80, $90, $BF, $FF ]
GOTO Decoder  '        0     1    2    3    4    5    6    7    8    9    -   off

Decoder:
PORTB.3=Digit.7:PORTB.2=Digit.6:PORTB.1=Digit.5:PORTB.0=Digit.4:PORTD.7=Digit.3:PORTD.6=Digit.2:PORTD.5=Digit.1:PORTD.4=Digit.0
PORTD.0=Cif.5:PORTD.1=Cif.4:PORTD.3=Cif.3:PORTC.4=Cif.2:PORTC.6=Cif.1:PORTC.7=Cif.0   '   
IF keyflag = 1 THEN NObutton
 IF MENUkey = 1 THEN MENUtime
 IF HIkey = 1 THEN HImenu
 IF LOWkey = 1 THEN LOWmenu
 IF OKkey = 1 THEN OKmenu
NObutton:
      tON.0 = TminON.0 : tON.1 = TminON.1 : tON.2 = TminON.2 : tON.3 = TminON.3 : tON.4 = TminON.4 : tON.5 = TminON.5 : tON.6 = TminON.6 : tON.7 = TminON.7
      tON.8 = ThourON.0 : tON.9 = ThourON.1 : tON.10 = ThourON.2 : tON.11 = ThourON.3 : tON.12 = ThourON.4 : tON.13 = ThourON.5 : tON.14 = ThourON.6 : tON.15 = ThourON.7      
      tOFF.0 = TminOFF.0 : tOFF.1 = TminOFF.1 : tOFF.2 = TminOFF.2 : tOFF.3 = TminOFF.3 : tOFF.4 = TminOFF.4 : tOFF.5 = TminOFF.5 : tOFF.6 = TminOFF.6 : tOFF.7 = TminOFF.7
      tOFF.8 = ThourOFF.0 : tOFF.9 = ThourOFF.1 : tOFF.10 = ThourOFF.2 : tOFF.11 = ThourOFF.3 : tOFF.12 = ThourOFF.4 : tOFF.13 = ThourOFF.5 : tOFF.14 = ThourOFF.6 : tOFF.15 = ThourOFF.7
DELAYMS 1 '   ,    -  
PORTC.3=0:PORTD.0=0:PORTD.1=0:PORTD.2=0:PORTD.3=0:PORTC.4=0:PORTC.5=0:PORTC.6=0:PORTC.7=0      
RETURN


MENUtime:
TMR1IE = 0 ' .  TMR1
keyflag = 1
IF MENUkey = 1 THEN MENUtime
FOR Cycle = 0 TO 255 
Raz = Mi DIG 0  '  
Cif = %00001000 
GOSUB DecoderP
Raz = Mi DIG 1  '  
Cif = %00000100
GOSUB DecoderP      
Raz = Ho DIG 0  '  
Cif = %00000010
GOSUB DecoderP
Raz = Ho DIG 1  '  
Cif = %00000001
GOSUB DecoderP
IF OKkey = 1 THEN MINcorrect 
NEXT Cycle
Cycle = 0
keyflag = 0
TMR1IE = 1 ' .  TMR1
TMR1IF = 0 '    TMR1
TIMER1 = 32768 ;  
GOTO Main

      MINcorrect:
      IF OKkey = 1 THEN MINcorrect
      FOR Cycle = 0 TO 100
      Raz = Mi DIG 0  '  
      Cif = %00001000 
      GOSUB DecoderNP
      Raz = Mi DIG 1  '  
      Cif = %00000100
      GOSUB DecoderNP
      NEXT Cycle
      MINcorrect1:      
      Raz = Mi DIG 0  '  
      Cif = %00001000 
      GOSUB DecoderP
      Raz = Mi DIG 1  '  
      Cif = %00000100
      GOSUB DecoderP
      IF HIkey = 1 THEN
      INC Mi
      IF Mi > 59 THEN Mi = 0
      GOTO MINcorrect
      ENDIF
      IF LOWkey = 1 THEN 
      DEC Mi
      IF Mi > 59 THEN Mi = 59
      GOTO MINcorrect
      ENDIF
      IF OKkey = 0 THEN MINcorrect1
      Wait1:
      IF OKkey = 1 THEN Wait1
      GOTO HOURcorrect     
 
           
      HOURcorrect:
      IF OKkey = 1 THEN HOURcorrect
      FOR Cycle = 0 TO 100
      Raz = Ho DIG 0  '  
      Cif = %00000010
      GOSUB DecoderNP
      Raz = Ho DIG 1  '  
      Cif = %00000001
      GOSUB DecoderNP
      NEXT Cycle
      HOURcorrect1:
      Raz = Ho DIG 0  '  
      Cif = %00000010
      GOSUB DecoderP
      Raz = Ho DIG 1  '  
      Cif = %00000001
      GOSUB DecoderP
      IF HIkey = 1 THEN 
      INC Ho
      IF Ho > 23 THEN Ho = 0
      GOTO HOURcorrect
      ENDIF
      IF LOWkey = 1 THEN 
      DEC Ho
      IF Ho > 23 THEN Ho = 23
      GOTO HOURcorrect
      ENDIF
      IF OKkey = 0 THEN HOURcorrect1
      Wait2:
      IF OKkey = 1 THEN Wait2
      GOTO ONminCorrect    
 

      ONminCorrect:
      IF OKkey = 1 THEN ONminCorrect
      FOR Cycle = 0 TO 100
      Raz = TminON DIG 0  '  
      Cif = %00001000 
      GOSUB DecoderNP
      Raz = TminON DIG 1  '  
      Cif = %00000100
      GOSUB DecoderNP
      NEXT Cycle
      ONMINcorrect1:      
      Raz = TminON DIG 0  '  
      Cif = %00001000 
      GOSUB DecoderP
      Raz = TminON DIG 1  '  
      Cif = %00000100
      GOSUB DecoderNP
      IF HIkey = 1 THEN
      INC TminON
      IF TminON > 59 THEN TminON = 0
      GOTO ONminCorrect
      ENDIF
      IF LOWkey = 1 THEN 
      DEC TminON
      IF TminON > 59 THEN TminON = 59
      GOTO ONminCorrect
      ENDIF
      IF OKkey = 0 THEN ONMINcorrect1
      Wait3:
      IF OKkey = 1 THEN Wait3  
      GOTO ONhourCorrect


      ONhourCorrect:
      IF OKkey = 1 THEN ONhourCorrect
      FOR Cycle = 0 TO 100
      Raz = ThourON DIG 0  '  
      Cif = %00000010
      GOSUB DecoderNP
      Raz = ThourON DIG 1  '  
      Cif = %00000001
      GOSUB DecoderNP
      NEXT Cycle
      ONHOURcorrect1:
      Raz = ThourON DIG 0  '  
      Cif = %00000010
      GOSUB DecoderP
      Raz = ThourON DIG 1  '  
      Cif = %00000001
      GOSUB DecoderNP
      IF HIkey = 1 THEN 
      INC ThourON
      IF ThourON > 23 THEN ThourON = 0
      GOTO ONhourCorrect
      ENDIF
      IF LOWkey = 1 THEN 
      DEC ThourON
      IF ThourON > 23 THEN ThourON = 23
      GOTO ONhourCorrect
      ENDIF
      IF OKkey = 0 THEN ONHOURcorrect1
      Wait4:
      IF OKkey = 1 THEN Wait4
      GOTO OFFminCorrect 

      OFFminCorrect:
      IF OKkey = 1 THEN OFFminCorrect
      FOR Cycle = 0 TO 100
      Raz = TminOFF DIG 0  '  
      Cif = %00001000 
      GOSUB DecoderNP
      Raz = TminOFF DIG 1  '  
      Cif = %00000100
      GOSUB DecoderNP
      NEXT Cycle
      OFFMINcorrect1:      
      Raz = TminOFF DIG 0  '  
      Cif = %00001000 
      GOSUB DecoderNP
      Raz = TminOFF DIG 1  '  
      Cif = %00000100
      GOSUB DecoderP
      IF HIkey = 1 THEN
      INC TminOFF
      IF TminOFF > 59 THEN TminOFF = 0
      GOTO OFFminCorrect
      ENDIF
      IF LOWkey = 1 THEN 
      DEC TminOFF
      IF TminOFF > 59 THEN TminOFF = 59
      GOTO OFFminCorrect
      ENDIF
      IF OKkey = 0 THEN OFFMINcorrect1
      Wait5:
      IF OKkey = 1 THEN Wait5  
      GOTO OFFhourCorrect

      OFFhourCorrect:
      IF OKkey = 1 THEN OFFhourCorrect
      FOR Cycle = 0 TO 100
      Raz = ThourOFF DIG 0  '  
      Cif = %00000010
      GOSUB DecoderNP
      Raz = ThourOFF DIG 1  '  
      Cif = %00000001
      GOSUB DecoderNP
      NEXT Cycle
      OFFHOURcorrect1:
      Raz = ThourOFF DIG 0  '  
      Cif = %00000010
      GOSUB DecoderNP
      Raz = ThourOFF DIG 1  '  
      Cif = %00000001
      GOSUB DecoderP
      IF HIkey = 1 THEN 
      INC ThourOFF
      IF ThourOFF > 23 THEN ThourOFF = 0
      GOTO OFFhourCorrect
      ENDIF
      IF LOWkey = 1 THEN 
      DEC ThourOFF
      IF ThourOFF > 23 THEN ThourOFF = 23
      GOTO OFFhourCorrect
      ENDIF
      IF OKkey = 0 THEN OFFHOURcorrect1
      Wait6:
      IF OKkey = 1 THEN Wait6
      keyflag = 0
      TMR1IE = 1 ' .  TMR1
      TMR1IF = 0 '    TMR1
      TIMER1 = 32768 ;  
      GOTO Main


HImenu: '  
        keyflag = 1
        FOR Cycle = 0 TO 255
        Raz = TminON DIG 0  '  
        Cif = %00001000 
        GOSUB DecoderP
        Raz = TminON DIG 1  '  
        Cif = %00000100
        GOSUB DecoderNP      
        Raz = ThourON DIG 0  '  
        Cif = %00000010
        GOSUB DecoderNP
        Raz = ThourON DIG 1  '  
        Cif = %00000001
        GOSUB DecoderNP 
        NEXT Cycle
        Cycle = 0
        keyflag = 0
GOTO Main

LOWmenu: '  
         keyflag = 1
         FOR Cycle = 0 TO 255
         Raz = TminOFF DIG 0  '  
         Cif = %00001000 
         GOSUB DecoderNP
         Raz = TminOFF DIG 1  '  
         Cif = %00000100
         GOSUB DecoderNP      
         Raz = ThourOFF DIG 0  '  
         Cif = %00000010
         GOSUB DecoderNP
         Raz = ThourOFF DIG 1  '  
         Cif = %00000001
         GOSUB DecoderP
         NEXT Cycle
         Cycle = 0 
         keyflag = 0
GOTO Main

OKmenu:  '    
keyflag = 1
DELAYMS 1000        '  ,     
keyflag = 0
GOTO Main


END      

